Summary: Mingw32 GNU Binary Utility Development Utilities
Name: crossmingw32
%define binversion 2.9.1.0.15
%define gccversion 2.8.1
%define version 990111
Version: %{version}
Release: 1
Copyright: GPL
Group: Development/Tools
Source: ftp://ftp.gnu.org/pub/gnu/binutils-%{binversion}.tar.gz
Source1: http://www.fu.is.saga-u.ac.jp/~colin/mingw32_980309_tar.gz
Source2: http://www.fu.is.saga-u.ac.jp/~colin/win32api980428_tar.gz
Source3: platform-010598.tar.gz
Source4: ftp://ftp.gnu.org/pub/gnu/gcc-%{gccversion}.tar.gz
Source5: ftp://ftp.gnu.org/pub/gnu/libstdc++-%{gccversion}.tar.gz
Patch0: binutils-2.9.1-sparcsectionreloc.patch
Patch1: binutils-2.9.1-emsparcv9.diff
Patch2: mingw32-980309.diff
Patch3: win32api-980428.diff
Patch4: gcc-2.8.1-template.diff
Patch5: libiberty.diff

%define target i386-mingw32
%define prefix /usr
%define arch %{prefix}/%{target}
%define gcclib %{prefix}/lib/gcc-lib/%{target}/%{gccversion}
%define gccarch %{prefix}/lib/gcc-lib/%{target}

%changelog
* Mon Jan 11 1999 David Sugar <dyfet@tycho.com>
- Modified heavily and then added all other useful stuff to cross build
  a complete mingw32 development system in a single RPM.  The original
  RPMS's would not build from source unless /usr/i386-ming32 already
  had cross-compiled lib stuff, so this one directly builds into
  /usr/i386-mingw32 rather than a buildroot so that it can be cleanly
  built on a system that was NEVER used for cross compiling before.  If
  somebody wants to untwist this web and make it buildroot friendly...

* Thu May 7 1998 Jan-Jaap van der Heijden <J.J.vanderHeijden@student.utwente.nl>
- Initial release (2.9.1)

%description
This is a complete cross-compiling development system for building
stand-alone Microsoft Windows applications under Linux using the Mingw32
build libraries.  This includes a binutils, gcc with g++ and objc, and
libstdc++, all cross targeted to i386-mingw32, along with supporting
Win32 libraries in 'coff' format from free sources.

%prep
if test -d %{arch} ; then
	echo "ERROR: Cross Compiler already installed!"
	exit -1
fi

%setup -T -c -a 0
(cd binutils-%{binversion}/bfd;
%patch -p0 -b .secreloc
)
(cd binutils-%{binversion}
%patch1 -p0 -b .emv9
)
%setup -T -D -a 1
%setup -T -D -a 2
%setup -T -D -a 3
dos2unix mingw32/include/*.h
dos2unix mingw32/include/sys/*.h
dos2unix mingw32/src/*.c
dos2unix mingw32/src/*.def
dos2unix win32/include/*.h
dos2unix win32/include/Windows32/*.h
dos2unix win32/src/*
%patch2 -p0
%patch3 -p0

%setup -T -D -a 4
%patch4 -p0

%setup -T -D -a 5
(cd libstdc++-%{gccversion} ;
%patch5 -p1
)

%build

# Because of a bug in binutils-2.9.1, a cross libbfd.so* is not named
# lib<target>bfd.so*. To prevent confusion with native binutils, we
# forget about shared libraries right now, and do not install libbfd.a
(cd binutils-%{binversion}
./configure --prefix=%{prefix} --libdir=%{arch}/temp --target=%{target}
make CFLAGS=-O2 LDFLAGS=-s all
make install
rm -rf %{arch}/temp
)
mkdir -p %{arch}/include
cp -a mingw32/include/* %{arch}/include
cp -a win32/include/* %{arch}/include
cp -a mingw32/lib/* %{arch}/lib
cp -a win32/lib/* %{arch}/lib
cp -a platform-010598/lib/* %{arch}/lib

%install
(cd gcc-%{gccversion}
./configure --prefix=%{prefix} --target=%{target} --bindir=%{arch}/bin \
	--with-gxx-include-dir=%{arch}/include/g++ --enable-threads

make CLFAGS="-O2" LDFLAGS="-s" TARGET_LIBGCC2_CFLAGS="-UCROSS_COMPILE"

# build libobjc.dll for Objective C
make CFLAGS="-O2" LDFLAGS="-s" TARGET_LIBGCC2_CFLAGS="-UCROSS_COMPILE" \
	DLLTOOL="%{target}-dlltool --as=%{target}-as" libobjc.dll 

# spec files for msvcrt*.dll configurations
for n in msvcrt msvcrt20 msvcrt40; do
	sed "s/crtdll/$n/g" <specs | sed "s/crt1/crt2/g" >specs.$n
done

make CLFAGS="-O2" LDFLAGS="-s" TARGET_LIBGCC_CFLAGS="-UCROSS_COMPILE" install
install -m 644 specs.msvcrt specs.msvcrt20 specs.msvcrt40 %{gcclib}
mv %{arch}/bin/%{target}-* %{prefix}/bin
)

# Now we start building any cross-compiled libraries that we wish to
# include in crossmingw32.  This can be done since the gcc cross-compiler
# is now live.

(cd libstdc++-%{gccversion}
mkdir %{target}
cd %{target}
../configure --prefix=%{prefix} --target=%{target} --exec-prefix=%{arch} \
	--with-gxx-include-dir=%{arch}/include/g++

make CFLAGS="-O2" CXXFLAGS="-O2" 
make CFLAGS="-O2" CXXFLAGS="-O2" install gxx_include_dir=%{arch}/include/g++
)

%files
%dir %{arch}
%dir %{gccarch}
%{gccarch}/*
%{prefix}/bin/%{target}-*
%{arch}/*
%{prefix}/man/man1/%{target}-*

# an ugly cleanup because we are not using BuildRoot.

%clean
rm -rf %{arch}
rm -rf %{gccarch}
rm -f %{prefix}/bin/%{target}-*
rm -f %{prefix}/man/man1/%{target}-*

